#ifndef softShield_h
#define softShield_h

#if ARDUINO < 100
	#include <WProgram.h>
#else
	#include <Arduino.h>
#endif

class softShield
{
    friend class softModule;
public:
	virtual void update(){};
	virtual void setup(){};
protected:
    softShield();
    virtual ~softShield();
private:
    softShield* m_next;
    softShield* m_prev;
};


class softModule
{
    friend class softShield;
public:
    static void update()
    {
        softShield* head = *GetHead();
        softShield* current = head;
        if (current)
        {
            do
            {
                current->update();
                current = current->m_next;
            } while( current != head);
        }
    }
    static void setup()
    {
        softShield* head = *GetHead();
        softShield* current = head;
        if (current)
        {
            do
            {
                current->setup();
                current = current->m_next;
            } while( current != head);
        }
    }
private:

    static void addShield(softShield* shield)
    {
        softShield** s_head = GetHead();
        if (!*s_head)
        {
            shield->m_next = shield;
            shield->m_prev = shield;
        }
        else
        {
            (*s_head)->m_prev->m_next = shield;
            shield->m_prev = (*s_head)->m_prev;
            (*s_head)->m_prev = shield;
            shield->m_next = (*s_head);
        }
        *s_head = shield;    
    }

    static void removeShield(softShield* shield)
    {
        softShield** s_head = GetHead();
        *s_head = shield->m_next;
        if (*s_head != shield)
        {
            shield->m_prev->m_next = shield->m_next;
            shield->m_next->m_prev = shield->m_prev;
        }
        else
        {
            *s_head = NULL;
        }
        shield->m_next = NULL;
        shield->m_prev = NULL;
    }
private:
    static softShield** GetHead()
    {
        static softShield* head = NULL;
        return &head;
    }
};
#endif